/* ***********************************************************
 * This file was automatically generated on 2024-02-27.      *
 *                                                           *
 * Mathematica Bindings Version 2.1.31                       *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures ambient light up to 64000lux
	/// </summary>
	public class BrickletAmbientLightV2 : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 259;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Ambient Light Bricklet 2.0";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ILLUMINANCE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ILLUMINANCE_CALLBACK_THRESHOLD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ILLUMINANCE_CALLBACK_THRESHOLD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_CONFIGURATION = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CONFIGURATION = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_ILLUMINANCE = 10;

		private const int CALLBACK_ILLUMINANCE_REACHED = 11;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';

		/// <summary>
		/// </summary>
		public const byte ILLUMINANCE_RANGE_UNLIMITED = 6;

		/// <summary>
		/// </summary>
		public const byte ILLUMINANCE_RANGE_64000LUX = 0;

		/// <summary>
		/// </summary>
		public const byte ILLUMINANCE_RANGE_32000LUX = 1;

		/// <summary>
		/// </summary>
		public const byte ILLUMINANCE_RANGE_16000LUX = 2;

		/// <summary>
		/// </summary>
		public const byte ILLUMINANCE_RANGE_8000LUX = 3;

		/// <summary>
		/// </summary>
		public const byte ILLUMINANCE_RANGE_1300LUX = 4;

		/// <summary>
		/// </summary>
		public const byte ILLUMINANCE_RANGE_600LUX = 5;

		/// <summary>
		/// </summary>
		public const byte INTEGRATION_TIME_50MS = 0;

		/// <summary>
		/// </summary>
		public const byte INTEGRATION_TIME_100MS = 1;

		/// <summary>
		/// </summary>
		public const byte INTEGRATION_TIME_150MS = 2;

		/// <summary>
		/// </summary>
		public const byte INTEGRATION_TIME_200MS = 3;

		/// <summary>
		/// </summary>
		public const byte INTEGRATION_TIME_250MS = 4;

		/// <summary>
		/// </summary>
		public const byte INTEGRATION_TIME_300MS = 5;

		/// <summary>
		/// </summary>
		public const byte INTEGRATION_TIME_350MS = 6;

		/// <summary>
		/// </summary>
		public const byte INTEGRATION_TIME_400MS = 7;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletAmbientLightV2.SetIlluminanceCallbackPeriod"/>. The parameter is the illuminance of the
		///  ambient light sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletAmbientLightV2.IlluminanceCallback"/> callback is only triggered if the illuminance has changed since the
		///  last triggering.
		/// </summary>
		public event IlluminanceEventHandler IlluminanceCallback;
		/// <summary>
		/// </summary>
		public delegate void IlluminanceEventHandler(BrickletAmbientLightV2 sender, long illuminance);

		/// <summary>
		/// </summary>
		public event IlluminanceEventHandler Illuminance // for backward compatibility
		{
			add { IlluminanceCallback += value; }
			remove { IlluminanceCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletAmbientLightV2.SetIlluminanceCallbackThreshold"/> is reached.
		///  The parameter is the illuminance of the ambient light sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletAmbientLightV2.SetDebouncePeriod"/>.
		/// </summary>
		public event IlluminanceReachedEventHandler IlluminanceReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void IlluminanceReachedEventHandler(BrickletAmbientLightV2 sender, long illuminance);

		/// <summary>
		/// </summary>
		public event IlluminanceReachedEventHandler IlluminanceReached // for backward compatibility
		{
			add { IlluminanceReachedCallback += value; }
			remove { IlluminanceReachedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletAmbientLightV2(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 1;

			callbackWrappers[CALLBACK_ILLUMINANCE] = new CallbackWrapper(OnIlluminanceCallback);
			callbackWrappers[CALLBACK_ILLUMINANCE_REACHED] = new CallbackWrapper(OnIlluminanceReachedCallback);


			responseExpected[FUNCTION_GET_ILLUMINANCE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ILLUMINANCE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ILLUMINANCE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CONFIGURATION] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_CONFIGURATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the illuminance of the ambient light sensor. The measurement range goes
		///  up to about 100000lux, but above 64000lux the precision starts to drop.
		///  
		///  .. versionchanged:: 2.0.2$nbsp;(Plugin)
		///    An illuminance of 0lux indicates an error condition where the sensor cannot
		///    perform a reasonable measurement. This can happen with very dim or very bright
		///    light conditions. In bright light conditions this might indicate that the sensor
		///    is saturated and the configuration should be modified (<see cref="Tinkerforge.BrickletAmbientLightV2.SetConfiguration"/>)
		///    to better match the light conditions.
		///  
		///  If you want to get the illuminance periodically, it is recommended to use the
		///  <see cref="Tinkerforge.BrickletAmbientLightV2.IlluminanceCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletAmbientLightV2.SetIlluminanceCallbackPeriod"/>.
		/// </summary>
		public long GetIlluminance()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ILLUMINANCE);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletAmbientLightV2.IlluminanceCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletAmbientLightV2.IlluminanceCallback"/> callback is only triggered if the illuminance has changed
		///  since the last triggering.
		/// </summary>
		public void SetIlluminanceCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletAmbientLightV2.SetIlluminanceCallbackPeriod"/>.
		/// </summary>
		public long GetIlluminanceCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletAmbientLightV2.IlluminanceReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the illuminance is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the illuminance is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the illuminance is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the illuminance is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetIlluminanceCallbackThreshold(char option, long min, long max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(17, FUNCTION_SET_ILLUMINANCE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((int)min, 9, request);
			LEConverter.To((int)max, 13, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletAmbientLightV2.SetIlluminanceCallbackThreshold"/>.
		/// </summary>
		public void GetIlluminanceCallbackThreshold(out char option, out long min, out long max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ILLUMINANCE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 17);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.UIntFrom(9, response);
			max = LEConverter.UIntFrom(13, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callbacks
		///  
		///  * <see cref="Tinkerforge.BrickletAmbientLightV2.IlluminanceReachedCallback"/>,
		///  
		///  are triggered, if the thresholds
		///  
		///  * <see cref="Tinkerforge.BrickletAmbientLightV2.SetIlluminanceCallbackThreshold"/>,
		///  
		///  keep being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletAmbientLightV2.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the configuration. It is possible to configure an illuminance range
		///  between 0-600lux and 0-64000lux and an integration time between 50ms and 400ms.
		///  
		///  .. versionadded:: 2.0.2$nbsp;(Plugin)
		///    The unlimited illuminance range allows to measure up to about 100000lux, but
		///    above 64000lux the precision starts to drop.
		///  
		///  A smaller illuminance range increases the resolution of the data. A longer
		///  integration time will result in less noise on the data.
		///  
		///  .. versionchanged:: 2.0.2$nbsp;(Plugin)
		///    If the actual measure illuminance is out-of-range then the current illuminance
		///    range maximum +0.01lux is reported by <see cref="Tinkerforge.BrickletAmbientLightV2.GetIlluminance"/> and the
		///    <see cref="Tinkerforge.BrickletAmbientLightV2.IlluminanceCallback"/> callback. For example, 800001 for the 0-8000lux range.
		///  
		///  .. versionchanged:: 2.0.2$nbsp;(Plugin)
		///    With a long integration time the sensor might be saturated before the measured
		///    value reaches the maximum of the selected illuminance range. In this case 0lux
		///    is reported by <see cref="Tinkerforge.BrickletAmbientLightV2.GetIlluminance"/> and the <see cref="Tinkerforge.BrickletAmbientLightV2.IlluminanceCallback"/> callback.
		///  
		///  If the measurement is out-of-range or the sensor is saturated then you should
		///  configure the next higher illuminance range. If the highest range is already
		///  in use, then start to reduce the integration time.
		/// </summary>
		public void SetConfiguration(byte illuminanceRange, byte integrationTime)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_CONFIGURATION);
			LEConverter.To((byte)illuminanceRange, 8, request);
			LEConverter.To((byte)integrationTime, 9, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickletAmbientLightV2.SetConfiguration"/>.
		/// </summary>
		public void GetConfiguration(out byte illuminanceRange, out byte integrationTime)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CONFIGURATION);

			byte[] response = SendRequest(request, 10);

			illuminanceRange = LEConverter.ByteFrom(8, response);
			integrationTime = LEConverter.ByteFrom(9, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnIlluminanceCallback(byte[] response)
		{
			if (response.Length != 12)
			{
				return; // silently ignoring callback with wrong length
			}

			long illuminance = LEConverter.UIntFrom(8, response);
			var handler = IlluminanceCallback;

			if (handler != null)
			{
				handler(this, illuminance);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnIlluminanceReachedCallback(byte[] response)
		{
			if (response.Length != 12)
			{
				return; // silently ignoring callback with wrong length
			}

			long illuminance = LEConverter.UIntFrom(8, response);
			var handler = IlluminanceReachedCallback;

			if (handler != null)
			{
				handler(this, illuminance);
			}
		}
	}
}
