/* ***********************************************************
 * This file was automatically generated on 2024-02-27.      *
 *                                                           *
 * Mathematica Bindings Version 2.1.31                       *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures contactless object temperature between -70°C and +380°C
	/// </summary>
	public class BrickletTemperatureIR : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 217;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Temperature IR Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_AMBIENT_TEMPERATURE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_OBJECT_TEMPERATURE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_EMISSIVITY = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_EMISSIVITY = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD = 12;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 13;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 14;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_AMBIENT_TEMPERATURE = 15;

		private const int CALLBACK_OBJECT_TEMPERATURE = 16;

		private const int CALLBACK_AMBIENT_TEMPERATURE_REACHED = 17;

		private const int CALLBACK_OBJECT_TEMPERATURE_REACHED = 18;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletTemperatureIR.SetAmbientTemperatureCallbackPeriod"/>. The parameter is the
		///  ambient temperature of the sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletTemperatureIR.AmbientTemperatureCallback"/> callback is only triggered if the ambient
		///  temperature has changed since the last triggering.
		/// </summary>
		public event AmbientTemperatureEventHandler AmbientTemperatureCallback;
		/// <summary>
		/// </summary>
		public delegate void AmbientTemperatureEventHandler(BrickletTemperatureIR sender, short temperature);

		/// <summary>
		/// </summary>
		public event AmbientTemperatureEventHandler AmbientTemperature // for backward compatibility
		{
			add { AmbientTemperatureCallback += value; }
			remove { AmbientTemperatureCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletTemperatureIR.SetObjectTemperatureCallbackPeriod"/>. The parameter is the
		///  object temperature of the sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletTemperatureIR.ObjectTemperatureCallback"/> callback is only triggered if the object
		///  temperature has changed since the last triggering.
		/// </summary>
		public event ObjectTemperatureEventHandler ObjectTemperatureCallback;
		/// <summary>
		/// </summary>
		public delegate void ObjectTemperatureEventHandler(BrickletTemperatureIR sender, short temperature);

		/// <summary>
		/// </summary>
		public event ObjectTemperatureEventHandler ObjectTemperature // for backward compatibility
		{
			add { ObjectTemperatureCallback += value; }
			remove { ObjectTemperatureCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletTemperatureIR.SetAmbientTemperatureCallbackThreshold"/> is reached.
		///  The parameter is the ambient temperature of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletTemperatureIR.SetDebouncePeriod"/>.
		/// </summary>
		public event AmbientTemperatureReachedEventHandler AmbientTemperatureReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void AmbientTemperatureReachedEventHandler(BrickletTemperatureIR sender, short temperature);

		/// <summary>
		/// </summary>
		public event AmbientTemperatureReachedEventHandler AmbientTemperatureReached // for backward compatibility
		{
			add { AmbientTemperatureReachedCallback += value; }
			remove { AmbientTemperatureReachedCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletTemperatureIR.SetObjectTemperatureCallbackThreshold"/> is reached.
		///  The parameter is the object temperature of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletTemperatureIR.SetDebouncePeriod"/>.
		/// </summary>
		public event ObjectTemperatureReachedEventHandler ObjectTemperatureReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void ObjectTemperatureReachedEventHandler(BrickletTemperatureIR sender, short temperature);

		/// <summary>
		/// </summary>
		public event ObjectTemperatureReachedEventHandler ObjectTemperatureReached // for backward compatibility
		{
			add { ObjectTemperatureReachedCallback += value; }
			remove { ObjectTemperatureReachedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletTemperatureIR(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_AMBIENT_TEMPERATURE] = new CallbackWrapper(OnAmbientTemperatureCallback);
			callbackWrappers[CALLBACK_OBJECT_TEMPERATURE] = new CallbackWrapper(OnObjectTemperatureCallback);
			callbackWrappers[CALLBACK_AMBIENT_TEMPERATURE_REACHED] = new CallbackWrapper(OnAmbientTemperatureReachedCallback);
			callbackWrappers[CALLBACK_OBJECT_TEMPERATURE_REACHED] = new CallbackWrapper(OnObjectTemperatureReachedCallback);


			responseExpected[FUNCTION_GET_AMBIENT_TEMPERATURE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_OBJECT_TEMPERATURE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_EMISSIVITY] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_EMISSIVITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the ambient temperature of the sensor.
		///  
		///  If you want to get the ambient temperature periodically, it is recommended
		///  to use the <see cref="Tinkerforge.BrickletTemperatureIR.AmbientTemperatureCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletTemperatureIR.SetAmbientTemperatureCallbackPeriod"/>.
		/// </summary>
		public short GetAmbientTemperature()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_AMBIENT_TEMPERATURE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.ShortFrom(8, response);
		}

		/// <summary>
		///  Returns the object temperature of the sensor, i.e. the temperature
		///  of the surface of the object the sensor is aimed at.
		///  
		///  The temperature of different materials is dependent on their `emissivity
		///  &lt;https://en.wikipedia.org/wiki/Emissivity&gt;`__. The emissivity of the material
		///  can be set with <see cref="Tinkerforge.BrickletTemperatureIR.SetEmissivity"/>.
		///  
		///  If you want to get the object temperature periodically, it is recommended
		///  to use the <see cref="Tinkerforge.BrickletTemperatureIR.ObjectTemperatureCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletTemperatureIR.SetObjectTemperatureCallbackPeriod"/>.
		/// </summary>
		public short GetObjectTemperature()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_OBJECT_TEMPERATURE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.ShortFrom(8, response);
		}

		/// <summary>
		///  Sets the `emissivity &lt;https://en.wikipedia.org/wiki/Emissivity&gt;`__ that is
		///  used to calculate the surface temperature as returned by
		///  <see cref="Tinkerforge.BrickletTemperatureIR.GetObjectTemperature"/>.
		///  
		///  The emissivity is usually given as a value between 0.0 and 1.0. A list of
		///  emissivities of different materials can be found
		///  `here &lt;https://www.infrared-thermography.com/material.htm&gt;`__.
		///  
		///  The parameter of <see cref="Tinkerforge.BrickletTemperatureIR.SetEmissivity"/> has to be given with a factor of
		///  65535 (16-bit). For example: An emissivity of 0.1 can be set with the
		///  value 6553, an emissivity of 0.5 with the value 32767 and so on.
		///  
		///  <note>
		///   If you need a precise measurement for the object temperature, it is
		///   absolutely crucial that you also provide a precise emissivity.
		///  </note>
		///  
		///  The emissivity is stored in non-volatile memory and will still be used after a restart or power cycle of the Bricklet.
		/// </summary>
		public void SetEmissivity(int emissivity)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_EMISSIVITY);
			LEConverter.To((short)emissivity, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the emissivity as set by <see cref="Tinkerforge.BrickletTemperatureIR.SetEmissivity"/>.
		/// </summary>
		public int GetEmissivity()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_EMISSIVITY);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletTemperatureIR.AmbientTemperatureCallback"/> callback is
		///  triggered periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletTemperatureIR.AmbientTemperatureCallback"/> callback is only triggered if the temperature has
		///  changed since the last triggering.
		/// </summary>
		public void SetAmbientTemperatureCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletTemperatureIR.SetAmbientTemperatureCallbackPeriod"/>.
		/// </summary>
		public long GetAmbientTemperatureCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletTemperatureIR.ObjectTemperatureCallback"/> callback is
		///  triggered periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletTemperatureIR.ObjectTemperatureCallback"/> callback is only triggered if the temperature
		///  has changed since the last triggering.
		/// </summary>
		public void SetObjectTemperatureCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletTemperatureIR.SetObjectTemperatureCallbackPeriod"/>.
		/// </summary>
		public long GetObjectTemperatureCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletTemperatureIR.AmbientTemperatureReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the ambient temperature is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the ambient temperature is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the ambient temperature is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the ambient temperature is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetAmbientTemperatureCallbackThreshold(char option, short min, short max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletTemperatureIR.SetAmbientTemperatureCallbackThreshold"/>.
		/// </summary>
		public void GetAmbientTemperatureCallbackThreshold(out char option, out short min, out short max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 13);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.ShortFrom(9, response);
			max = LEConverter.ShortFrom(11, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletTemperatureIR.ObjectTemperatureReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the object temperature is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the object temperature is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the object temperature is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the object temperature is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetObjectTemperatureCallbackThreshold(char option, short min, short max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletTemperatureIR.SetObjectTemperatureCallbackThreshold"/>.
		/// </summary>
		public void GetObjectTemperatureCallbackThreshold(out char option, out short min, out short max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 13);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.ShortFrom(9, response);
			max = LEConverter.ShortFrom(11, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callbacks
		///  
		///  * <see cref="Tinkerforge.BrickletTemperatureIR.AmbientTemperatureReachedCallback"/>,
		///  * <see cref="Tinkerforge.BrickletTemperatureIR.ObjectTemperatureReachedCallback"/>
		///  
		///  are triggered, if the thresholds
		///  
		///  * <see cref="Tinkerforge.BrickletTemperatureIR.SetAmbientTemperatureCallbackThreshold"/>,
		///  * <see cref="Tinkerforge.BrickletTemperatureIR.SetObjectTemperatureCallbackThreshold"/>
		///  
		///  keep being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletTemperatureIR.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnAmbientTemperatureCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			short temperature = LEConverter.ShortFrom(8, response);
			var handler = AmbientTemperatureCallback;

			if (handler != null)
			{
				handler(this, temperature);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnObjectTemperatureCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			short temperature = LEConverter.ShortFrom(8, response);
			var handler = ObjectTemperatureCallback;

			if (handler != null)
			{
				handler(this, temperature);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnAmbientTemperatureReachedCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			short temperature = LEConverter.ShortFrom(8, response);
			var handler = AmbientTemperatureReachedCallback;

			if (handler != null)
			{
				handler(this, temperature);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnObjectTemperatureReachedCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			short temperature = LEConverter.ShortFrom(8, response);
			var handler = ObjectTemperatureReachedCallback;

			if (handler != null)
			{
				handler(this, temperature);
			}
		}
	}
}
