Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XXYYZZ\>\"", RowBox[{"(*", "Change XXYYZZ to the UID of your Servo Brick", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"servo", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickServo\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Use position reached callback to swing back and forth", "*)"}],
   RowBox[{RowBox[{"PositionReachedCB", "[", RowBox[{"sender_", ",", "servoNum_", ",", "position_"}], "]"}], ":=", "\[IndentingNewLine]", RowBox[{"Module", "[", RowBox[{RowBox[{"{", "}"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{"position", "==", "9000"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"Print", "[", "\"\<Position: 90\.b0, going to -90\.b0\>\"", "]"}], ";", "\[IndentingNewLine]", "sender", "@", RowBox[{"SetPosition", "[", RowBox[{"servoNum", ",", RowBox[{"-", "9000"}]}], "]"}], "\[IndentingNewLine]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{"position", "==", "-", "9000"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"Print", "[", "\"\<Position: -90\.b0, going to 90\.b0\>\"", "]"}], ";", "\[IndentingNewLine]", "sender", "@", RowBox[{"SetPosition", "[", RowBox[{"servoNum", ",", "9000"}], "]"}], "\[IndentingNewLine]"}]}], "]"}], "\[IndentingNewLine]"}]}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"AddEventHandler", "[", RowBox[{RowBox[{"servo", "@", "PositionReachedCallback"}], ",", "PositionReachedCB"}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Enable position reached callback", "*)"}],
   RowBox[{"servo", "@", RowBox[{"EnablePositionReachedCallback", "[", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Set velocity to 100\.b0/s. This has to be smaller or equal to the", "*)"}],
   RowBox[{"(*", "maximum velocity of the servo you are using, otherwise the position", "*)"}],
   RowBox[{"(*", "reached callback will be called too early", "*)"}],
   RowBox[{"servo", "@", RowBox[{"SetVelocity", "[", RowBox[{"0", ",", "10000"}], "]"}]}],
   RowBox[{"servo", "@", RowBox[{"SetPosition", "[", RowBox[{"0", ",", "9000"}], "]"}]}],
   RowBox[{"servo", "@", RowBox[{"Enable", "[", "0", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"Input", "[", "\"\<Click OK to exit\>\"", "]"}],
   RowBox[{"
"}],
   RowBox[{"servo", "@", RowBox[{"Disable", "[", "0", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "servo", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
