Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your Linear Poti Bricklet", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"lp", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletLinearPoti\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Callback function for position callback", "*)"}],
   RowBox[{RowBox[{"PositionCB", "[", RowBox[{"sender_", ",", "position_"}], "]"}], ":=", "\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Position: \>\"", "<>", RowBox[{"ToString", "[", RowBox[{"N", "[", RowBox[{"Quantity", "[", RowBox[{"position", ",", "\"\<%\>\""}], "]"}], "]"}], "]"}]}], "]"}], RowBox[{"(*", "Range: 0 to 100", "*)"}]}],
   RowBox[{"AddEventHandler", "[", RowBox[{RowBox[{"lp", "@", "PositionCallback"}], ",", "PositionCB"}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Set period for position callback to 0.05s (50ms)", "*)"}],
   RowBox[{"(*", "Note: The position callback is only called every 0.05 seconds", "*)"}],
   RowBox[{"(*", "if the position has changed since the last call!", "*)"}],
   RowBox[{"lp", "@", RowBox[{"SetPositionCallbackPeriod", "[", "50", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"Input", "[", "\"\<Click OK to exit\>\"", "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "lp", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
